.386
.MODEL FLAT

.CODE
_run:

include         stdparas.inc                            ; PA1-chgL
include         abpstruc.inc                            ; asmBmpPara-structure

; *********************************************************************************************

asmBmpPara      EQU     <PA1>
chgH            EQU     <PA2>
chgS            EQU     <PA3>
chgL            EQU     <PA4>

fct             EQU     <stack1>
svESI           EQU     <stack3>

; *********************************************************************************************

changeHSL       PROC    NEAR

init:           mac     SAVE
                push    100000h                         ; => fct

                mov     ebx,asmBmpPara
                mov     esi,srcBits
                mov     edi,tgtBits
                mov     ecx,tgtWidth
                imul    ecx,tgtHeight
                
bmp_loop:       push    ecx            
                xor     ebx,ebx                         ; get min/max/dif/sum
                mov     ecx,ebx
                lodsb
                mov     cl,al
                mov     bl,al
                lodsb
                cmp     bl,al
                jc      getMax
                xchg    al,bl
getMax:         mov     cl,al
                lodsb
                cmp     bl,al
                jc      getMax1
                mov     bl,al
getMax1:        cmp     cl,al
                jnc     getMax2
                mov     cl,al
getMax2:        push    esi                             ; => svESI
                push    edi
                lea     esi,[ecx+ebx]                   ; esi = sum
                mov     edi,ecx                         ; ecx = max
                sub     edi,ebx                         ; edi = dif
		

getS:           mov     ebx,chgS
                or      ebx,ebx
                jns     getL                            ; S = chgS
                mov     ebx,esi
                cmp     ebx,255
                jc      getS1
                sub     ebx,510                         ; S = dif/(2-sum)
                neg     ebx
getS1:          or      ebx,ebx
                jz      getL
                mov     eax,edi                         ; S = dif/sum
                shl     eax,20
                cdq
                div     ebx
                mov     ebx,eax                         ; ebx = S (0, if dif=0)

getL:           mov     eax,esi                         ; L = Max(1,sum/2 * chgL)
                shl     eax,19
                cdq
                mov     esi,255
                div     esi
                mov     esi,fct
                test    Byte Ptr [ebp+23],80h           ; (chgL high)
                jnz     getL1
                mul     chgL
                div     esi
getL1:          xchg    eax,esi
                cmp     esi,eax
                jbe     newMax
                mov     esi,eax                         ; esi = L


newMax:         or      ebx,ebx                         ; get new min/max
                jnz     newMax1
                mov     eax,esi
                mov     ebx,esi
                jmp     setTgt                          ; S = 0 => R:=G:=B:=L

newMax1:        cmp     esi,80000h                      ; L >=.5 ?
                jc      newMax2
                sub     eax,esi                         ; min1 = L-(1-L)*s
                mul     ebx
                div     fct
                sub     eax,esi
                neg     eax
                jmp     newMax3

newMax2:        sub     eax,ebx                         ; min1 = (1-s)*L
                mul     esi
                div     fct
newMax3:        mov     ebx,eax                         ; ebx = min1
                shl     esi,1
                sub     esi,ebx                         ; esi = max1 (=2*L-min1)


getH:           mov     eax,chgH
                or      eax,eax	
                jns     getRGB                          ; H = chgH

                or      edi,edi
                jnz     getH1
                lea     eax,[esi+ebx]
                shr     eax,1
                jmp     getRGB                          ; dif =0 => H = L


getH1:          mov     edx,svESI
                xor     eax,eax
                cmp     cl,[edx-3]                      ; max = [red]?
                jnz     getH2
                mov     al,[edx-2]
                cmp     al,cl                           ; max = [green]?
                jz      getH3
                mov     ecx,fct                         ; max = [red]!
                sub     al,[edx-1]
                jc      getH5
                jmp     getH6

getH2:          cmp     cl,[edx-2]                      ; max = [green]?
                jnz     getH4
getH3:          mov     al,[edx-1]
                cmp     al,cl                           ; max = [blue]?
                jz      getH4
                mov     ecx,300000h                     ; max = [green]!
                sub     al,[edx-3]
                jc      getH5
                jmp     getH6

getH4:          mov     al,[edx-3]                      ; max = [blau]!
                mov     ecx,500000h
                sub     al,[edx-2]
                jnc     getH6
getH5:          neg     al
                neg     eax
getH6:          cdq
                imul    fct
                idiv    edi
                add     eax,ecx                         ; eax = hue


getRGB:         mov     edi,fct
                mov     ecx,eax
                and     eax,0FFFFFh
                ror     ecx,21
                jc      getRGB1
                sub     eax,edi
                neg     eax
getRGB1:        mov     edx,esi
                sub     edx,ebx
                mul     edx
                div     edi
                add     eax,ebx
                shl     ecx,1
                jnc     getRGB2
                xchg    eax,ebx
getRGB2:        cmp     cl,2
                jz      setTgt
                xchg    eax,esi
                xchg    eax,ebx
                jnc     setTgt
                xchg    eax,esi
                xchg    eax,ebx

setTgt:         pop     edi
                mov     ecx,255
                mul     ecx
                shr     eax,20
                adc     eax,0
                cmp     eax,ecx
                jbe     setTgt1
                mov     al,cl
setTgt1:        stosb
                mov     eax,esi
                mul     ecx
                shr     eax,20
                adc     eax,0
                cmp     eax,ecx
                jbe     setTgt2
                mov     al,cl
setTgt2:        stosb
                mov     eax,ebx
                mul     ecx
                shr     eax,20
                adc     eax,0
                cmp     eax,ecx
                jbe     setTgt3
                mov     eax,ecx
setTgt3:        stosb
        
                pop     esi                             ; finish bmp_loop
                pop     ecx
                movsb
                dec     ecx
                jnz     bmp_loop

                stc
                pop     eax
finish:         mac     REST

changeHSL       ENDP

END _run
