Attribute VB_Name = "asm_ChangeHSL"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

' asmChangeHSL
'
' CALL          asmChangeHSL(ptr:lpAsmBmpPara, [HV], [SV], [LV])
'
' IN:           lng:ptr Points to asmBmpPara-structure
'               sgl:HV  Hue-Value: <0 = ignore (default)
'                                 >=0 = 0 to 255
'               sgl:SV  Satuation: <0 = ignore (default)
'                                 >=0 = set absolut
'               sgl:LV  Lightness: <0 = ignore (default)
'                                 >=0 = percentage to multiply with
'
' Remarks:      internally, the asm-function works with longs;
'               in order to simulate decimals, all parameters
'               are multiplied with 2^20 (&H100000)
'
' OUT:          bol     success
'
Function asmChangeHSL(lpAsmBmpPara As Long, _
    Optional ByVal HV As Single = -1, _
    Optional ByVal SV As Single = -1, _
    Optional ByVal LV As Single = -1) As Boolean
    
    Static asm(100) As Long

    If asm(0) = 0 Then
        asm(0) = &HEC8B5590:  asm(1) = &H68575653:  asm(2) = &H100000:    asm(3) = &H8B085D8B
        asm(4) = &H7B8B1473:  asm(5) = &H1C4B8B2C:  asm(6) = &H204BAF0F:  asm(7) = &H8BDB3351
        asm(8) = &HC88AACCB:  asm(9) = &H38ACD88A:  asm(10) = &H860272C3: asm(11) = &HACC88AC3
        asm(12) = &H272C338:  asm(13) = &HC138D88A: asm(14) = &HC88A0273: asm(15) = &H348D5756
        asm(16) = &H2BF98B0B: asm(17) = &H105D8BFB: asm(18) = &H2079DB0B: asm(19) = &HFB81DE8B
        asm(20) = &HFF:       asm(21) = &HEB810872: asm(22) = &H1FE:      asm(23) = &HDB0BDBF7
        asm(24) = &HC78B0A74: asm(25) = &H9914E0C1: asm(26) = &HD88BF3F7: asm(27) = &HE0C1C68B
        asm(28) = &HFFBE9913: asm(29) = &HF7000000: asm(30) = &HF0758BF6: asm(31) = &H801745F6
        asm(32) = &H65F70575: asm(33) = &H96F6F714: asm(34) = &H276F03B:  asm(35) = &HDB0BF08B
        asm(36) = &HC68B0975: asm(37) = &HADE9DE8B: asm(38) = &H81000000: asm(39) = &H80000FE
        asm(40) = &H2B0D7200: asm(41) = &HF7E3F7C6: asm(42) = &HC62BF075: asm(43) = &H7EBD8F7
        asm(44) = &HE6F7C32B: asm(45) = &H8BF075F7: asm(46) = &H2BE6D1D8: asm(47) = &HC458BF3
        asm(48) = &H5779C00B: asm(49) = &H775FF0B:  asm(50) = &HD133048D: asm(51) = &H8B4CEBE8
        asm(52) = &HC033E855: asm(53) = &H75FD4A3A: asm(54) = &HFE428A11: asm(55) = &HF74C838
        asm(56) = &H2AF04D8B: asm(57) = &H2772FF42: asm(58) = &H4A3A29EB: asm(59) = &H8A1375FE
        asm(60) = &HC838FF42: asm(61) = &HB90C74:   asm(62) = &H2A003000: asm(63) = &HF72FD42
        asm(64) = &H428A11EB: asm(65) = &HB9FD&:    asm(66) = &H422A0050: asm(67) = &HF60473FE
        asm(68) = &H99D8F7D8: asm(69) = &HF7F06DF7: asm(70) = &H8BC103FF: asm(71) = &HC88BF07D
        asm(72) = &HFFFFF25:  asm(73) = &H15C9C100: asm(74) = &HC72B0472: asm(75) = &HD68BD8F7
        asm(76) = &HE2F7D32B: asm(77) = &HC303F7F7: asm(78) = &H173E1D1:  asm(79) = &H2F98093
        asm(80) = &H93960674: asm(81) = &H93960273: asm(82) = &HFFB95F:   asm(83) = &HE1F70000
        asm(84) = &H8314E8C1: asm(85) = &HC13B00D0: asm(86) = &HC18A0276: asm(87) = &HF7C68BAA
        asm(88) = &H14E8C1E1: asm(89) = &H3B00D083: asm(90) = &H8A0276C1: asm(91) = &HC38BAAC1
        asm(92) = &HE8C1E1F7: asm(93) = &HD08314:   asm(94) = &H276C13B:  asm(95) = &H5EAAC18B
        asm(96) = &HF49A459:  asm(97) = &HFFFE9385: asm(98) = &H1B58F9FF: asm(99) = &H5B5E5FC0
        asm(100) = &H10C25D
    End If

    ' ************************************************************

    If HV >= 0 Then HV = HV * &H100000
    If SV >= 0 Then SV = SV * &H100000
    If LV >= 0 Then LV = LV * &H100000
    
    asmChangeHSL = CallWindowProc(asm(0), lpAsmBmpPara, CLng(HV), CLng(SV), CLng(LV))
End Function

' basRGB2HSL    Convert RGB to HSL
'
' CALL:         basRGB2HSL(R, G, B, @H, @S, @L)
'
' IN:           lng:R   red
'               lng:G   green
'               lng:B   blue
'
' OUT:          sgl:H   hue
'               sgl:S   saturation
'               sgl:L   lightness
'
Public Function basRGB2HSL(R As Byte, G As Byte, B As Byte, _
    h As Single, S As Single, l As Single)
    
    Dim max     As Single
    Dim min     As Single
    Dim dif     As Single
    Dim sum     As Single
    Dim svR     As Single
    Dim svG     As Single
    Dim svB     As Single

    svR = R / 255
    svG = G / 255
    svB = B / 255

    max = svR
    If max < svG Then max = svG
    If max < svB Then max = svB
    
    min = svR
    If min > svG Then min = svG
    If min > svB Then min = svB
    
    sum = max + min
    dif = max - min
    
    h = 0
    S = 0
    l = sum / 2

    If dif Then
        If l > 0.5 Then
            S = dif / (2 - sum)
        Else
            S = dif / sum
        End If
            
        Select Case max
            Case svR: h = 0 + (svG - svB) / dif
            Case svG: h = 2 + (svB - svR) / dif
            Case svB: h = 4 + (svR - svG) / dif
        End Select
      End If
End Function

' basChangeHSL
'
' AUFRUF:       basChangeHSL(src, tgt, [HV], [SV], [LV])
'
' EIN:          sgl:HV  Hue-Value: <0 = ignorieren (Vorgabe)
'                                 >=0 = absolut setzen
'               sgl:SV  Satuation: <0 = ignorieren (Vorgabe)
'                                 >=0 = absolut setzen
'               sgl:LV  Lightness: <0 = ignorieren (Vorgabe)
'                                 >=0 = Mit Prozentsatz multiplizieren
'
' AUS:          log     Erfolg
'
Function basChangeHSL(src() As Byte, tgt() As Byte, _
    Optional HValue As Single = -1, _
    Optional SValue As Single = -1, _
    Optional LFactor As Single = -1) As Boolean
    
    Dim X1  As Long
    Dim Y1  As Long
    Dim H1  As Single
    Dim S1  As Single
    Dim L1  As Single
    Dim R   As Long
    Dim G   As Long
    Dim B   As Long
    
    For X1 = 1 To UBound(src, 1) Step 4
        For Y1 = 1 To UBound(src, 2)
            basRGB2HSL src(X1 + 0, Y1), _
                       src(X1 + 1, Y1), _
                       src(X1 + 2, Y1), _
                       H1, S1, L1
            
            If HValue >= 0 Then H1 = HValue - 1
            If SValue >= 0 Then S1 = SValue
            If LFactor >= 0 Then L1 = L1 * LFactor: If L1 > 1 Then L1 = 1
                            
            basHSL2RGB H1, S1, L1, _
                       tgt(X1 + 0, Y1), _
                       tgt(X1 + 1, Y1), _
                       tgt(X1 + 2, Y1)
        Next
    Next
    
    basChangeHSL = True
End Function

' basHSL2RGB    Convert HSL to RGB
'
' CALL:         basRGB2HSL(H, S, L, @R, @G, @B)
'
' IN:           sgl:H   hue
'               sgl:S   saturation
'               sgl:L   lightness
'
' OUT:          lng:R   red
'               lng:G   green
'               lng:B   blue
'
Public Function basHSL2RGB(h As Single, S As Single, l As Single, _
    R As Byte, G As Byte, B As Byte) As Long
    
    Dim svR As Single
    Dim svG As Single
    Dim svB As Single
    Dim min As Single
    Dim max As Single
    Dim dif As Single
    
    If S = 0 Then
        svR = l
        svG = l
        svB = l
        
    Else
        If l > 0.5 Then
            min = l - S * (1 - l)
        Else
            min = l * (1 - S)
        End If
      
        max = 2 * l - min
        dif = max - min
        
        Select Case h
            Case Is < 0: svR = max: svG = min: svB = min - (h * dif)
            Case Is < 1: svR = max: svB = min: svG = min + (h * dif)
            Case Is < 2: svG = max: svB = min: svR = min + (2 - h) * dif
            Case Is < 3: svG = max: svR = min: svB = min + (h - 2) * dif
            Case Is < 4: svB = max: svR = min: svG = min + (4 - h) * dif
            Case Else:   svB = max: svG = min: svR = min + (h - 4) * dif
        End Select
    End If
   
    svR = svR * 255: If svR > 255 Then svR = 255
    svG = svG * 255: If svG > 255 Then svG = 255
    svB = svB * 255: If svB > 255 Then svB = 255

    R = IIf(svR < 0, 0, svR)
    G = svG
    B = svB
End Function
